import * as ts from 'typescript/lib/tsserverlibrary';
import ts__default from 'typescript/lib/tsserverlibrary';
import * as vue from '@vue/language-core';

declare function createLanguage(tsconfigPath: string, ts?: typeof ts): {
    updateFile(fileName: string, text: string): void;
    deleteFile(fileName: string): void;
    reload(): void;
    clearCache(): void;
    findNodeByRange: (filepath: string, filter: (ranges: vue.ScriptSetupRanges) => vue.TextRange | undefined) => {
        virtualFileNode: ts__default.Node;
        scriptNode: ts__default.Node;
        setupRange: vue.TextRange;
        offset: number;
    } | undefined;
    getScriptSetupAst: (filepath: string) => ts__default.SourceFile | undefined;
    getVirtualFileAst: (filepath: string) => ts__default.SourceFile | undefined;
    traverseAst: (filepath: string, cb: (node: ts__default.Node, context: {
        scriptSetupAst?: ts__default.SourceFile | undefined;
        virtualFileOrTsAst: ts__default.SourceFile;
        isVirtualOrTsFile: boolean;
    }) => void) => void;
    __internal__: {
        tsLs: ts__default.LanguageService;
        program: ts__default.Program;
        typeChecker: ts__default.TypeChecker;
    };
};
type Language = ReturnType<typeof createLanguage>;
declare function ensureLanguage(tsconfigPath: string): void;
declare function getLanguage(): Language;

export { ensureLanguage, getLanguage };
